DEFINE CLASS bkiError AS CUSTOM

	PROTECTED oColErrorStack && Platz fr smtliche Fehlermeldungen

	***************************
	*** Public
	***************************
	*--------------------------------------------------------------------------------------------
	*-- Initialisierung der Instanz
	*--------------------------------------------------------------------------------------------
	PROCEDURE INIT()

		DODEFAULT()
		THIS.createErrorStack()
	ENDPROC

	*--------------------------------------------------------------------------------------------
	*-- Aufrumen der Instanz
	*--------------------------------------------------------------------------------------------
	PROCEDURE DESTROY()

		THIS.oColErrorStack = .NULL.
		DODEFAULT()
	ENDPROC

	*-------------------------------------------------------------------------------------------
	*-- Gibt den letzten aufgetretenen Fehler des Errorstacks zurck
	*-------------------------------------------------------------------------------------------
	PROCEDURE getLastError() AS STRING

		RETURN THIS.oColErrorStack.ITEM(THIS.oColErrorStack.COUNT).NAME
	ENDPROC

	*-------------------------------------------------------------------------------------------
	*-- Gibt den ErrorStack als ganzes zwecks separater Auswertung zurck
	*-------------------------------------------------------------------------------------------
	PROCEDURE getErrorStack() AS COLLECTION

		RETURN THIS.oColErrorStack
	ENDPROC

	*-------------------------------------------------------------------------------------------
	*-- Eine Fehlermeldung auf den Stack schieben
	*-------------------------------------------------------------------------------------------
	PROCEDURE appendError(fehler AS STRING)

		THIS.oColErrorStack.ADD(fehler)
	ENDPROC

	*-------------------------------------------------------------------------------------------
	*-- ErrorStack leeren
	*-------------------------------------------------------------------------------------------
	PROCEDURE clearErrorStack()

		*-- Subern erfolgt durch Neuanlegen des Errorstacks
		THIS.oColErrorStack = .NULL.
		THIS.createErrorStack()
	ENDPROC

	*-------------------------------------------------------------------------------------------
	*-- Erzeugt einen neuen ErrorStack, wenn noch nicht vorhanden
	*--------------------------------------------------------------------------------------------
	PROCEDURE createErrorStack() AS COLLECTION

		IF TYPE("this.oColErrorStack") != "O"
			THIS.oColErrorStack = CREATEOBJECT("collection")
		ENDIF
	ENDPROC

ENDDEFINE
